set nocompatible

" Various options
set formatoptions=cq
set cpoptions-=$<
set ruler
set scrolloff=1
set encoding=utf-8
set nostartofline
set autowrite
set lazyredraw
set autowrite

set listchars=tab:>·,trail:¤
set list

" Tabulation
set tabstop=4
set shiftwidth=4
set expandtab

" Search options
set hlsearch
set ignorecase
set smartcase
set incsearch

" set format textwidth so that the text fits in a 80 columns window
set textwidth=79

" Command line completion
set wildmode=list:longest,full
set wildignore=CVS/

filetype on
filetype plugin on
filetype indent on
syntax on
se cindent

noremap <F12> <C-]>
noremap <F11> <C-T>

set cindent
set cinkeys=0{,0},!^F,o,O,e " default is: 0{,0},0),:,0#,!^F,o,O,e

let mapleader=','

" buffer navigation
" Use TAB key in normal mode to switch buffers
nnoremap <TAB> <C-W>w
nnoremap <S-TAB> <C-W>W

" use ² (square) two switch between alternate buffer
nnoremap ² :b#<CR>

" These settings are from http://clavier-dvorak.org/wiki/Utilisateur:Kaze/vimrc
" but a little customized
" I need another Esc key
inoremap <Tab> <Esc>
vnoremap <Tab> <Esc>
inoremap <S-Tab> <Tab>
vnoremap <S-Tab> <Tab>
inoremap <S-Return> <Esc>
vnoremap <S-Return> <Esc>
inoremap <M-Return> <Esc>
vnoremap <M-Return> <Esc>

" lazy scrolling
noremap <S-BS> <C-u>
noremap <S-Space> <C-d>
noremap <S-Return> zt

map <F10> :set paste<CR>
map <F9> :set nopaste<CR>
imap <F10> <C-O>:set paste<CR>
imap <F9> <nop>
set pastetoggle=<F9>

nnoremap <Leader>q :.,$g/^/ normal@
vnoremap <Leader>q :g/^/ normal@

nnoremap <Leader>g :noau vim // ./**/*

set bg=dark

" GUI stuff
if has( "gui_running" )
    set bg=light
    colorscheme molokai
    set guifont=ProggySquareTT\ 12
    set guioptions=a
else
    " color scheme for the console
    colorscheme tango
endif

" local settings
" settings for idutils.vim plugin
let g:IGlidcmd="D:\\gnu\\bin\\lid.exe -R grep"
nnoremap <Leader>l :IDGrep <CR>

"return '[\s]' if trailing white space is detected
"return '' otherwise
function! StatuslineTrailingSpaceWarning()
    if !exists("b:statusline_trailing_space_warning")
        if search('\s\+$', 'nw') != 0
            let b:statusline_trailing_space_warning = '[\s]'
        else
            let b:statusline_trailing_space_warning = ''
        endif
    endif
    return b:statusline_trailing_space_warning
endfunction

"return '[&et]' if &et is set wrong
"return '[mixed-indenting]' if spaces and tabs are used to indent
"return an empty string if everything is fine
function! StatuslineTabWarning()
        if !exists("b:statusline_tab_warning")
        let tabs = search('^\t', 'nw') != 0
        let spaces = search('^ ', 'nw') != 0

        if tabs && spaces
            let b:statusline_tab_warning =  '[mixed-indenting]'
        elseif (spaces && !&et) || (tabs && &et)
            let b:statusline_tab_warning = '[&et]'
        else
            let b:statusline_tab_warning = ''
        endif
    endif
    return b:statusline_tab_warning
endfunction

"return a warning for "long lines" where "long" is either &textwidth or 80 (if
"no &textwidth is set)
"
"return '' if no long lines
"return '[#x,my,$z] if long lines are found, were x is the number of long
"lines, y is the median length of the long lines and z is the length of the
"longest line
function! StatuslineLongLineWarning()
    if !exists("b:statusline_long_line_warning")
        let long_line_lens = s:LongLines()

        if len(long_line_lens) > 0
            let b:statusline_long_line_warning = "[" .
                        \ '#' . len(long_line_lens) . "," .
                        \ 'm' . s:Median(long_line_lens) . "," .
                        \ '$' . max(long_line_lens) . "]"
        else
            let b:statusline_long_line_warning = ""
        endif
    endif
    return b:statusline_long_line_warning
endfunction

"return a list containing the lengths of the long lines in this buffer
function! s:LongLines()
    let threshold = (&tw ? &tw : 80)
    let spaces = repeat(" ", &ts)

    let long_line_lens = []

    let i = 1
    while i <= line("$")
        let len = strlen(substitute(getline(i), '\t', spaces, 'g'))
        if len > threshold
            call add(long_line_lens, len)
        endif
        let i += 1
    endwhile

    return long_line_lens
endfunction

"find the median of the given array of numbers
function! s:Median(nums)
    let nums = sort(a:nums)
    let l = len(nums)

    if l % 2 == 1
        let i = (l-1) / 2
        return nums[i]
    else
        return (nums[l/2] + nums[(l/2)-1]) / 2
    endif
endfunction


" {{{ Nice statusbar
"statusline setup
set statusline=%f       "tail of the filename

"display a warning if fileformat isnt unix
set statusline+=%#warningmsg#
set statusline+=%{&ff!='unix'?'['.&ff.']':''}
set statusline+=%*

"display a warning if file encoding isnt utf-8
set statusline+=%#warningmsg#
set statusline+=%{(&fenc!='utf-8'&&&fenc!='')?'['.&fenc.']':''}
set statusline+=%*

set statusline+=%h      "help file flag
set statusline+=%y      "filetype
set statusline+=%r      "read only flag
set statusline+=%m      "modified flag

"display a warning if &et is wrong, or we have mixed-indenting
set statusline+=%#error#
set statusline+=%{StatuslineTabWarning()}
set statusline+=%*

set statusline+=%{StatuslineTrailingSpaceWarning()}

set statusline+=%#warningmsg#
set statusline+=%*

"display a warning if &paste is set
set statusline+=%#error#
set statusline+=%{&paste?'[paste]':''}
set statusline+=%*

set statusline+=%=      "left/right separator
set statusline+=%{StatuslineCurrentHighlight()}\ \ "current highlight
set statusline+=%c,     "cursor column
set statusline+=%l/%L   "cursor line/total lines
set statusline+=\ %P    "percent through file
set laststatus=2        " Always show status line

"return the syntax highlight group under the cursor ''
function! StatuslineCurrentHighlight()
    let name = synIDattr(synID(line('.'),col('.'),1),'name')
    if name == ''
        return ''
    else
        return '[' . name . ']'
    endif
endfunction

"recalculate the trailing whitespace warning when idle, and after saving
autocmd cursorhold,bufwritepost * unlet! b:statusline_trailing_space_warning

